/****************************************************************************
** Form implementation generated from reading ui file 'settings.ui'
**
** Created: Fri Dec 22 16:50:45 2000
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#include "settings.h"
#include "utils.h"
#include <fstream>

//#include <qcombobox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <klocale.h>
/*#include <kapp.h>*/
#include <qmessagebox.h>
#include <stdlib.h>


Settings::Settings( QTrans* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    Par = parent;

    if ( !name )
	setName( "this" );
    setFixedSize( 350, 243 );
    setCaption(i18n("Settings"));
    setSizeGripEnabled( TRUE );

    /*bHelp = new QPushButton( this, "bHelp" );
    bHelp->setGeometry(10,this->height()-30,60,25);
    bHelp->setText("&Help");
    bHelp->setAutoDefault( TRUE );*/

    bApply = new QPushButton(this,"bApply" );
    bApply->setGeometry(this->width()-210,this->height()-38,60,35);
    bApply->setText(i18n("&Apply"));
    bApply->setAutoDefault( TRUE );

    bOk = new QPushButton(this, "bOk" );
    bOk->setGeometry(this->width()-140,this->height()-38,60,35);
    bOk->setText(i18n("&OK"));
    bOk->setAutoDefault( TRUE );
    bOk->setDefault( TRUE );

    bCancel = new QPushButton(this, "buttonCancel" );
    bCancel->setGeometry(this->width()-70,this->height()-38,60,35);
    bCancel->setText(i18n("&Cancel"));
    bCancel->setAutoDefault( TRUE );

    TabWidget = new QTabWidget( this, "TabWidget" );
    TabWidget->setGeometry( QRect( 10, 10, this->width()-20, 190 ) );

    /*--- Dictionaries Panel ---*/
    tab1 = new QWidget( TabWidget, "tab" );

    TextLabel1 = new QLabel( tab1, "TextLabel1" );
    TextLabel1->setGeometry( QRect( 10, 10, 200, 20 ) );
    TextLabel1->setText(i18n("English dic :"));

    TextLabel2 = new QLabel( tab1, "TextLabel2" );
    TextLabel2->setGeometry( QRect( 10, 67, 200, 20 ) );
    TextLabel2->setText(i18n("Specific dic :"));

    /*cLang = new QComboBox( FALSE, tab1, "cLang" );
    cLang->setGeometry( QRect( 90, 80, 251, 21 ) );
    cLang->setCurrentItem( -2 );*/

    lEng = new QLineEdit( tab1, "lEng" );
    lEng->setGeometry( QRect( 10, 35, 251, 22 ) );

    lSpec = new QLineEdit( tab1, "lSpec" );
    lSpec->setGeometry( QRect(10, 92, 250, 22 ) );
    TabWidget->insertTab( tab1,i18n("Dictionaries"));

    /*--- Misc Panel ---*/
    tab2 = new QWidget( TabWidget, "tab_2" );
    TabWidget->insertTab( tab2,i18n("Misc"));

    AutoPop = new QCheckBox( tab2, "AutoPop" );
    AutoPop->setGeometry( QRect( 20, 10, 150, 25 ) );
    AutoPop->setText(i18n("Enable Auto Pop-Up"));

    DontClose = new QCheckBox( tab2, "Dontclose" );
    DontClose->setGeometry( QRect( 20, 35, 250, 25 ) );
    DontClose->setText(i18n("Minimize when press Exit button"));

    DockIcon = new QCheckBox( tab2, "DockIcon" );
    DockIcon->setGeometry( QRect( 20, 60, 200, 25 ) );
    DockIcon->setText(i18n("Enable System Tray dock icon"));

    StartMin = new QCheckBox(tab2,"StartMin");
    StartMin->setGeometry( QRect( 50, 85, 200, 25 ) );
    StartMin->setText(i18n("Start Minimized"));

    /*-- ShortCut Panel --*/
    tab3 = new QWidget( TabWidget, "tab_3" );
    TabWidget->insertTab( tab3,i18n("ShortCut"));

    EnableShortCut = new QCheckBox(tab3,"Enable_shortCut");
    EnableShortCut->setGeometry( QRect( 20, 10, 250, 25 ) );
    EnableShortCut->setText(i18n("Enable Hide/Show shortcut"));

    Char = new KComboBox(FALSE,tab3,"combobox");
    Char->setGeometry(QRect(130,40,40,25));
    int i=0;
    for (char a='A';a<='Z';a++) Char->insertItem(QString(QChar(a)),i++);

    TextLabel3 = new QLabel( tab3, "TextLabel3" );
    TextLabel3->setGeometry( QRect( 20, 40, 110, 20 ) );
    TextLabel3->setText(i18n("Keys  : CTRL + "));

    // signals and slots connections
    connect( bOk, SIGNAL( clicked() ), this, SLOT(slot_Ok()));
    connect( bCancel, SIGNAL( clicked() ), this, SLOT(slot_close()));
    connect( bApply, SIGNAL(clicked()),this,SLOT(slot_apply()));
    connect(DockIcon,SIGNAL(clicked()),this,SLOT(slot_DockIcon()));

    /*-- Load Configuration from current settings --*/
    lEng->setText(str(parent->English_Path));
    lSpec->setText(str(parent->Lang_Path));
    if (parent->AutoPopUp) AutoPop->setChecked(TRUE);
    if (parent->DockIcon) {
       DockIcon->setChecked(TRUE);
       StartMin->setEnabled(TRUE);
       if (parent->StartMin) StartMin->setChecked(TRUE);
    } else StartMin->setEnabled(FALSE);
    if (parent->DontClose) DontClose->setChecked(TRUE);
    if (parent->enableShortCut) EnableShortCut->setChecked(TRUE);
    if (parent->ShortKey!="") {
      QChar c = parent->ShortKey[5];
      for (int i=0;i<=25;i++) if (Char->text(i)==c) {Char->setCurrentItem(i);break;}
    }
}

Settings::~Settings()
{
}

void Settings::slot_close() {
   close();
}

void Settings::slot_Ok() {
   slot_apply();
   close();
}

/*-- Update the Configuration File --*/
/*-- And now change also the current settings!! --*/
void Settings::slot_apply() {
   if (lEng->text()=="" || lSpec->text()=="") {
      QMessageBox::warning( this, "QTrans",
                      i18n("You must enter both the paths!"), "Ok", 0,0, 1 );
   }
   else {
      QString home=getenv("HOME");
      home=home+"/.qtrans/translate.conf";
      ofstream cFile(home,ios::out);
      cFile << "# QTrans Configuration file \n#\n#  Each line must terminate with the semicolon ';'\n" ;
      cFile << "\nENGDIC="+lEng->text()+";"; Par->English_Path=lEng->text();
      cFile << "\nLANG="+lSpec->text()+";"; Par->Lang_Path=lSpec->text();

      if (AutoPop->isChecked()) {cFile << "\nAUTOPOPUP=TRUE;";Par->AutoPopUp=TRUE;}
      else {cFile << "\nAUTOPOPUP=FALSE;";Par->AutoPopUp=FALSE;}

      if (DontClose->isChecked()) {cFile << "\nDONTCLOSE=TRUE;";Par->DontClose=TRUE;}
      else {cFile << "\nDONTCLOSE=FALSE;";Par->DontClose=FALSE;}

      if (DockIcon->isChecked()) {
         cFile << "\nDOCKENABLED=TRUE;"; Par->DockIcon=TRUE; Par->Dock->show();
         if (StartMin->isChecked()) {cFile << "\nSTARTMIN=TRUE;";Par->StartMin=TRUE;}
         else {cFile << "\nSTARTMIN=FALSE;";Par->StartMin=FALSE;}
      }
      else {cFile << "\nDOCKENABLED=FALSE;\nSTARTMIN=FALSE;";
            Par->DockIcon=FALSE;Par->Dock->hide();
            Par->StartMin=FALSE;
            if (!Par->isVisible()) Par->slot_ShortCut();
           }
      if (EnableShortCut->isChecked()) {cFile << "\nENABLE_SHORT_CUT=TRUE;";Par->enableShortCut=TRUE;}
      else {cFile << "\nENABLE_SHORT_CUT=FALSE;";Par->enableShortCut=FALSE;delete Par->ShortCut;}
      cFile << "\nSHORT_KEY=CTRL+" + Char->currentText() + ";";
      Par->ShortKey= "CTRL+"+Char->currentText();

      cFile.close();

      if (Par->enableShortCut) {
        Par->ShortCut = new KGlobalAccel();
        Par->ShortCut->insertItem( i18n("Show/Hide"), "show/hide",Par->ShortKey);
        Par->ShortCut->connectItem( "show/hide",Par, SLOT(slot_ShortCut()));
        Par->ShortCut->readSettings();
      }
   }
}

void Settings::slot_DockIcon() {
   if (DockIcon->isChecked()) StartMin->setEnabled(TRUE);
   else {
      StartMin->setEnabled(FALSE);
      StartMin->setChecked(FALSE);
   }
}

